<svelte:options customElement="my-input" />

<!------------ FUTUR HAS COME !!! ------------> 
<!-- 
  Svelte + Vite (Rollup) to build web-component
  ---------------------------------------------
  1- Import the custom element in main.js
  2- Build the bundle with npm run build 
  3- Import the lib from dist/index_xxx.js to
import { myInput } from  index_xxx.js 

Use this custom element in any JS project !!

In vue3 :

            <my-input
              placeholder="Saisir 2 texte !"
              :value="myButtonTextFn"
              @inputChange="myButtonTextFn2"
            />

ENJOY !!!

-->

<script lang="ts">
  // This is the two-way binding to parent
  // Catch it with @inputChange with vue
  import { createEventDispatcher } from "svelte";
// Those are the FUNKY $props.
export let placeholder = "Saisir un texte";
export let label = "bind:value";
export let value = "";
export let fnCallback = (c) => c;

// use this next line for reactive data with bind:value
$: onValueChanged(value), (() => {
  // console.log("${value}" +` ::: ${value}`)
  fnCallback(`CallbackFn :: ${value}`)
})();

$: fnCallback(value)

// Event dispatcher
let dispatch = createEventDispatcher()

const onValueChanged = (e) => {
  // e: InputEvent
  dispatch('inputChange', e)
}

</script>
<!-- my-input TEMPLATE -->
<label> {label} <input type="file" {placeholder} bind:value /></label>
<slot />